#!/usr/bin/perl -w

package LexisConflate;
## use strict;

use Encode;
use utf8;
@ISA = ('Exporter');
@EXPORT_OK = ('latin_greek_mixed', 'remove_egklitikos_tonos', 'remove_englitikos_tonos');

sub latin_greek_mixed {
    
    my $greek_letters = "αβγδεζηθικλμνξοπρσςτυφχψωάέήίϊΐόύϋΰώΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩΆΈΉΊΪΌΎΫΏ";

#    chomp;

    my @letter_array = ();

    my $word_tmp = $_[0];
    # Encode::_utf8_on( $word_tmp);    

    # string is ab c(de#
    @letter_array = split(//, $word_tmp);
    my $string = "";
    

    my $i;

    # string will become #a#b$$# #c$$#(#d#e$$##
    for ($i = 0; $i <= $#letter_array; $i++) {
	if ($letter_array[$i] =~ /[ \t\~\`\!\@\#\$\%\^\&\*\(\)\-\_\+\=\\\|\{\}\[\]\;\:\'\"\<\>\,\.\?\/]/) {
	    $string .= "|TOK|#" . $letter_array[$i];  
	} else {
	    $string .= "#" . $letter_array[$i];
	} 
    }

    my @string_elements = ();    
    # Split to "words and other chars"
    @string_elements = split(/\|TOK\|/, $string);
    

    my $num = 0;

    for ($num = 0; $num <= $#string_elements; $num++) {

	my @word_chars = ();

	# Split to letters
	@word_chars = split(//, $string_elements[$num]);
	
	$string_elements[$num] = "";
	

	my $ii = 0;
	# Put everything back together apart from #'s
	for ($ii = 1; $ii <= $#word_chars; $ii++) {
	    $string_elements[$num] .= $word_chars[$ii];
	    $ii++;
	}
	

	if (($string_elements[$num] =~ /[A-Z]|[a-z]/) && ($string_elements[$num] =~ /[$greek_letters]/)) {

	    print STDERR "TOK $_[0]\n";

	    # Check for the number of greek and latin letters
	    my $letter_num = 0;
	    my $latin_letters_num = 0;
	    my $greek_letters_num = 0;
	    my %is_latin = ();
	    my %is_greek = ();
	    my %is_letter = ();
	    my @letters = ();
	    my $letter;
	    @letters = split(//, $string_elements[$num],);
	    

	    foreach $letter (@letters) {
		if ($letter =~ /[A-Z]|[a-z]/) {
		    $latin_letters_num++;
		    $letter_num++;
		    $is_latin{$latin_letters_num} = $letter_num;
		    $is_letter{$letter_num} = $letter;
		} elsif ($letter =~ /[$greek_letters]/) {
		    $greek_letters_num++;
		    $letter_num++;
		    $is_greek{$greek_letters_num} = $letter_num;
		    $is_letter{$letter_num} = $letter;
		} else {
		    $letter_num++;
		    $is_letter{$letter_num} = $letter;
		}
	    }

	    # The existence of some greek letters will make the word greek, no matter what the number of latin letters is
	    if (($greek_letters_num >= $latin_letters_num) || ($string_elements[$num] =~ /[αγδεζθλμξπρσςφψάέήίϊΐόύϋΰώΓΔΘΛΞΠΣΦΨΩΆΈΉΊΪΌΎΫΏ]/) ) {

		my $temp = $string_elements[$num];
#		print "The, probably \"greek\", word\n";
#		print "$string_elements[$num]\n";
#		print "seems to have $latin_letters_num latin letter(s):\n";

		my $changes = 0;
		my $no_changes = 0;

		for ($i = 1; $i <= $latin_letters_num; $i++) {
#		    print "$is_letter{$is_latin{$i}}\n";
		    my $replacement = &lat2gr($is_letter{$is_latin{$i}});

		    if ($replacement ne $is_letter{$is_latin{$i}}) { 
			$is_letter{$is_latin{$i}} = $replacement;
			$changes++;
		    } else {
#		print "Can't decide on a proper replacement for $is_letter{$is_latin{$i}}. Moving on ...\n";
			$no_changes++;
		    }
		    
		}

		$string_elements[$num] = "";
		for ($i = 1; $i <= $letter_num; $i++) {
		    $string_elements[$num] .= $is_letter{$i};
		}
		if ($temp eq $string_elements[$num]) {
#		    print "No change here\n\n";
		} else {
#		    print "OK, the word is now $string_elements[$num]\n\n";
		}
		
	    } elsif ($latin_letters_num > $greek_letters_num) {
#		print STDERR "LAT $_[0]\n";
		my $temp = $string_elements[$num];
#		print "The, probably \"latin\", word\n";
#		print "$string_elements[$num]\n";
#		print "seems to have $greek_letters_num greek letter(s):\n";
		my $changes = 0;
		my $no_changes = 0;

		for ($i = 1; $i <= $greek_letters_num; $i++) {
#		    print "$is_letter{$is_greek{$i}}\n";
		    my $replacement = &gr2lat($is_letter{$is_greek{$i}});

		    if ($replacement ne $is_letter{$is_greek{$i}}) { 

			#print "$replacement\n";
			$is_letter{$is_greek{$i}} = $replacement;
			$changes++;
			
		    } else {
			
#		print "Can't decide on a proper replacement for $is_letter{$is_greek{$i}}. Moving on ...\n";
			$no_changes++;
			
		    }
		    
		}

		$string_elements[$num] = "";

		for ($i = 1; $i <= $letter_num; $i++) {
		    $string_elements[$num] .= $is_letter{$i};
		}
		if ($temp eq $string_elements[$num]) {
#		    print "No change here\n\n";
		} else {
#		    print "OK, the word is now $string_elements[$num]\n\n";
		}

	    }

	}

    }

    # Join everything back again to form the original string
    my $output = join("", @string_elements);
    return "$output";
}     

################# PACKAGE FUNCTIONS ############################

sub remove_egklitikos_tonos {
    # ταυτότητά της -> ταυτότητα της
    my $count = 0;
    my @fields = split(//, $_[0]);
    my $string;
    my $letter;
    foreach $letter (@fields) {
	if (($letter =~ /[άέήίόύώΐΰΆΈΉΊΌΎΏ]/) && ($count == 1)) {
	    $letter =~ tr/άέήίόύώΐΰΆΈΉΊΌΎΏ/αεηιουωϊϋΑΕΗΙΟΥΩ/;
	} elsif ($letter =~ /[άέήίόύώΐΰΆΈΉΊΌΎΏ]/) {
	    $count++;
	}
	$string .= $letter;
    }
    return $string;
}


sub remove_englitikos_tonos {
    return remove_egklitikos_tonos($_[0]);
}


sub lat2gr{

    my $replacement = $_[0];
    $replacement =~ tr/aezikouxABEZHIKMNOPTYX/αεζικουχΑΒΕΖΗΙΚΜΝΟΡΤΥΧ/;
    return($replacement);
}

sub gr2lat{
    my $replacement = $_[0];
    $replacement =~ tr/αεζικουχΑΒΕΖΗΙΚΜΝΟΡΤΥX/aezikouxABEZHIKMNOPTYX/;
    return($replacement);
}


################################
1;





